import numpy as np
import pandas as pd
import math
import matplotlib.pyplot as plt

def my_function(x):
    z = math.exp(x[0]) * (4*x[0]**2 + 2*x[1]**2 + 4*x[0]*x[1]+2*x[1]+1)
    return z

def gradient1(x):
    z = math.exp(x[0]) * (4*x[0]**2 + 2*x[1]**2 + 4*x[0]*x[1] + 8*x[0] + 6*x[1] + 1)
    return z

def gradient2(x):
    z = math.exp(x[0]) * (4*x[0] + 4*x[1] + 2)
    return z

l = 0.1
tolerance = 0.00000001
maxsteps = 100
cost_function = np.zeros((1,maxsteps))
x = np.zeros((1,maxsteps))
y = np.zeros((1,maxsteps))
x_initial1 = 0.1
x_initial2 = -0.1
count = 0

w = [x_initial1, x_initial2]
x[0,count] = w[0] 
y[0,count] = w[1]
cost_function[count] = my_function(w)

while ((count<maxsteps)&(abs(my_function(w))>tolerance)):
    d = [gradient1(w), gradient2(w)]
    w[0] = w[0] - l * d[0]
    w[1] = w[1] - l * d[1]    
    x[0, count] = w[0]
    y[0, count] = w[1]
    cost_function[0, count] = my_function(w)
    count = count + 1    

plt.plot([r for r in range(count)], cost_function[0,:count], 'r-')

plt.xlabel('Steps')
plt.ylabel('Cost Function')
plt.title('λ = 1')
plt.show()
